#include "defs.h"
#include "gis.h"

typedef struct vector
{
	double x;
	double y;
	double z;
}Svector;

typedef struct raster
{
	int x;
	int y;
}Sraster;

typedef struct matrix4
{
	float m[4][4];
}Smatrix4;

typedef struct matrix3
{
	double m[3][3];
}Smatrix3;

typedef struct hypothesis
{
	BOOL *type; /** the ones set to TRUE are the ones in that hypothesis **/
	double bel; /* belief */
	double pl;  /* plausability */
	double bint; /* belief interval = |Pl-Bel| = measure of uncertainty */
	double doubt; /* doubt */
	double common; /* commonality */	
	double bpn; /* basic probability number assignment */
	int isNull;
} Shypothesis;

/* global file pointers for access to evidence maps */
typedef struct fp_struct 
{
	int *fp;
} Sfp_struct;

typedef struct result_struct
{
	char valname[6];
	unsigned short use;
	DCELL **row;
	char **filename;
	int *fd;
	long *hyp_idx;
	struct Colors **colors;
} Sresult_struct;
