/* this program lists all Dempste-Shafer knowledge bases */
/* in the "DST" element under the user's current location */
/* DST files are recognised only, if the second line starts */
/* with the '<dst-kb' tag !!! */

#include "gis.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

int
main (int argc, char *argv[])
{
	struct GModule *module;			
	struct dirent **namelist;
	struct stat buf;
	char sbuf [BUFSIZ];
	FILE *fp;
	char *sysstr;
	int i,n;
	
	sysstr = G_calloc (255, sizeof (char));
	module = G_define_module ();
	module->description = "List all Dempster-Shafer knowledge base files in the current mapset.";
	/* setup some basic GIS stuff */
	G_gisinit (argv[0]);
	/* do not pause after a warning message was displayed */
	G_sleep_on_error (0);
	
	sprintf (sysstr,"%s/%s/DST", G_location_path(), G_mapset());	
	chdir (sysstr);
	n = scandir(".", &namelist, 0, alphasort);
    if (n < 0)
       	G_fatal_error ("Could not scan directory %s.", sysstr);
    else {
		for ( i = 0; i < n; i++ ) {
			stat ( namelist[i]->d_name, &buf);
			if (S_ISREG (buf.st_mode)){
				fp = fopen (namelist[i]->d_name, "r");
				if ( fp != NULL ) {
					fgets (sbuf, BUFSIZ, fp);
					fgets (sbuf, 8, fp); /* second line should contain the dst-identifier */
					if ( !strcmp ( sbuf, "<dst-kb" ) ) {
						fprintf (stdout, "%s\n", namelist[i]->d_name);
					}
				}
			}
			G_free (namelist[i]);
		}
		G_free (namelist);
	}					
	
	G_free (sysstr);
	G_free (namelist);
	return 0;
}
