#include "gis.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* ISSUES

	- make sure that pathnames are platform independent
	- make sure that Gmakefile will work on other platforms

*/

int
main (int argc, char *argv[])
{
	struct GModule *module;
	struct
	{
		struct Option *filename;
	}
	parm;
	struct
	{
		struct Flag *quiet;
		struct Flag *gui;
	}
	flag;

	FILE *kb; /* knowledge base */
	char *rmfile;
		
	rmfile = (char*) G_malloc (255 * sizeof (char));
	module = G_define_module ();
	module->description = "PERMANENTLY delete a Dempster-Shafer knowledge base.";
	/* setup some basic GIS stuff */
	G_gisinit (argv[0]);
	/* do not pause after a warning message was displayes */
	G_sleep_on_error (0);

	/* Parameters */
	parm.filename = G_define_option ();
	parm.filename->key = "file";
	parm.filename->type = TYPE_STRING;
	parm.filename->required = YES;
	parm.filename->description = "filename of the knowledge base to delete.";

	/* parse command line */
	if (G_parser (argc, argv))
	{
		exit (-1);
	}

	rmfile = G_find_file ("DST",parm.filename->answer,G_mapset());
	if (rmfile == NULL) {
		G_fatal_error ("Knowledge base not found in user's MAPSET!\n");
	}
	
	/* remove file from disk */
	G_remove ("DST",parm.filename->answer);
	
	G_free (rmfile);
	
	return 0;
}
