#include "gis.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* ISSUES

	- make sure that pathnames are platform independent
	- make sure that Gmakefile will work on other platforms

*/

int
main (int argc, char *argv[])
{
	struct GModule *module;
	struct
	{
		struct Option *old;
		struct Option *new;			
	}
	parm;
	struct
	{
		struct Flag *quiet;
		struct Flag *gui;
	}
	flag;
	
	module = G_define_module ();
	module->description = "Rename a Dempster-Shafer knowledge base.";
	/* setup some basic GIS stuff */
	G_gisinit (argv[0]);
	/* do not pause after a warning message was displayed */
	G_sleep_on_error (0);

	/* Parameters */
	parm.old = G_define_option ();
	parm.old->key = "old";
	parm.old->type = TYPE_STRING;
	parm.old->required = YES;
	parm.old->description = "Existing filename of the knowledge base.";
	
	parm.new = G_define_option ();
	parm.new->key = "new";
	parm.new->type = TYPE_STRING;
	parm.new->required = YES;
	parm.new->description = "New filename for the knowledge base.";	

	/* parse command line */
	if (G_parser (argc, argv))
	{
		exit (-1);
	}

	/* check if given parameters are valid */
	if (G_legal_filename (parm.old->answer) == -1) {
		G_fatal_error ("Please provide a legal filename!\n");
	}
		
	if (G_find_file ("DST",parm.old->answer,G_mapset()) == NULL) {
		G_fatal_error ("Knowledge base does not exist in user's MAPSET!\n");
	}
		
	/* rename file */
	G_rename ("DST",parm.old->answer,parm.new->answer);
	
	return 0;
}
